import type { Extension } from '@codemirror/state';
import type { EditorView } from '@codemirror/view';
export declare function extensionManager(...initialExtensions: Extension[]): Extension;
export type FlatExtension = Exclude<Extension, readonly Extension[]>;
export declare function wrapExtension(extension: Extension): FlatExtension;
export interface ExtensionOptions {
    flattenDepth?: number;
}
export type RemoveExtension = () => void;
export declare function addExtension(view: EditorView, extension: Extension, { flattenDepth }?: ExtensionOptions): RemoveExtension;
export declare function removeExtension(view: EditorView, extension: Extension, { flattenDepth }?: ExtensionOptions): void;
export declare function clearExtensions(view: EditorView): void;
export declare function hasExtension(view: EditorView, extension: Extension): boolean;
//# sourceMappingURL=extensionManager.d.ts.map