import type { Extension } from '@codemirror/state';
import type { ViewUpdate } from '@codemirror/view';
import { EditorView } from '@codemirror/view';
export type ViewUpdateListener = (update: ViewUpdate) => void;
export interface ViewUpdateListenerAction {
    add?: ViewUpdateListener[];
    remove?: ViewUpdateListener[];
    clear?: boolean;
}
export declare const ViewUpdateListenerEffect: import("@codemirror/state").StateEffectType<ViewUpdateListenerAction>;
export declare function viewUpdateListeners(...initialListeners: ViewUpdateListener[]): Extension;
export type Unsubscribe = () => void;
export declare function addViewUpdateListener(view: EditorView, listener: ViewUpdateListener): Unsubscribe;
export declare function removeViewUpdateListener(view: EditorView, listener: ViewUpdateListener): void;
export declare function clearViewUpdateListeners(view: EditorView): void;
//# sourceMappingURL=viewUpdateListeners.d.ts.map